
	include "tios.h"

	xdef _library
	xdef _ti89
	xdef _ti92plus

	xdef graphlib@0000	;fill		;OK
	xdef graphlib@0001	;put_sprite	;OK
	xdef graphlib@0002	;smallbox	;OK
	xdef graphlib@0003	;box		;OK
	xdef graphlib@0004	;frame	;OK
	xdef graphlib@0005	;clr_scr	;OK
	xdef graphlib@0006	;vert		;OK
	xdef graphlib@0007	;horiz	;OK
	xdef graphlib@0008	;bigbox	;OK
	xdef graphlib@0009	;scrtomem	;OK
	xdef graphlib@000A	;memtoscr	;OK
	xdef graphlib@000B	;put_sprite_mask	;OK
	xdef graphlib@000C	;put_sprite2	;OK
	xdef graphlib@000D	;choosescreen	;OK
	xdef graphlib@000E	;gray2	;OK
	xdef graphlib@000F	;gray4	;OK
	xdef graphlib@0010	;gray7	;OK
	xdef graphlib@0011	;plane0	;OK
	xdef graphlib@0012	;plane1	;OK
	xdef graphlib@0013	;plane2	;OK
	xdef graphlib@0014	;clr_scr2		;OK
	xdef graphlib@0015	;show_dialog	;OK
	xdef graphlib@0016	;clear_dialog	;OK
	xdef graphlib@0017	;line		;OK
	xdef graphlib@0018	;erase_rect	;OK
	xdef graphlib@0019	;frame_rect	;OK
	xdef graphlib@001A	;getlength	;OK

graphlib@0002
smallbox:
	movem.l	d0-d3,-(a7)
	moveq #25,d0
	moveq #20,d1
	moveq #110,d2
	moveq #60,d3
	tst.b CALCULATOR
	beq.s small89
	moveq #40,d0
	moveq #25,d1
	move.w #158,d2
	moveq #76,d3
small89:
	bsr.s box
	movem.l	(a7)+,d0-d3
	RTS

graphlib@0008
bigbox:
	movem.l d0-d3,-(a7)
	clr.w d0
	clr.w d1
	move.w #LCD_WIDTH-2,d2
	move.w #LCD_HEIGHT-8,d3
	bsr.s box
	movem.l (a7)+,d0-d3
	RTS

graphlib@0003
box:
;Input: d0.w = x
;	d1.w = y
;	d2.w = width
;	d3.w = height
;	a0.l = title of the box
	movem.l	d0-d7/a0-a6,-(a7)
	moveq #1,d4		;en blanc
	bsr fill

	move.w d2,d4
	move.w d3,d5
	addq.w #1,d4
	addq.w #1,d5

	bsr.s commun2

	move.w d4,d2
	moveq #8,d3
	moveq #2,d4		;en noir
	bsr fill		;le cadre noir en haut

	addq.w #2,d0
	addq.w #2,d1

	movem.l d0-d1/a0,-(a7)
	clr.w -(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
	move.w d0,d7
	movem.l (a7)+,d0-d1/a0

	WriteStrA d0,d1,#2,a0

	move.w d7,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7

	movem.l	(a7)+,d0-d7/a0-a6
	RTS

commun2:
	bsr.s frame

	addq.w #1,d0
	addq.w #1,d1
	subq.w #2,d4
	subq.w #2,d5
	bsr.s frame

	addq.w #2,d0
	addq.w #2,d1
	subq.w #4,d4
	subq.w #4,d5
	bsr.s frame
	RTS

graphlib@0004
frame:
;Input: d0.w = x
;	d1.w = y
;	d4.w = width
;	d5.w = height
	movem.l	d0-d5,-(a7)
	moveq #2,d3	;pour faire du noir

	move.w d0,d2	;pour x2
	add.w d4,d2
	bsr.s horiz
	add.w d5,d1
	bsr.s horiz

	sub.w d5,d1
	move.w d1,d2
	add.w d5,d2
	bsr.s vert
	add.w d4,d0
	bsr.s vert

	movem.l	(a7)+,d0-d5
	RTS

graphlib@0006
vert:
;Input:	d0.w = x
;	d1.w = y1
;	d2.w = y2
	movem.l	d0-d4/a1,-(a7)
	cmp.w d1,d2
	bgt.s plus
	exg d1,d2
plus:
	sub.w d1,d2	;hauteur
	bsr.s commun
lignevert:
	bset d0,(a1)
	lea 30(a1),a1
	dbra d2,lignevert
	movem.l	(a7)+,d0-d4/a1
	RTS

commun:
	bsr screen
	add.w d1,d1
	move.w d1,d4
	lsl.w #4,d1
	sub.w d4,d1		;x*30
	move.w d0,d4
	lsr.w #3,d4
	add.w d4,d1
	add.w d1,a1
	not.b d0
	andi.b #7,d0
	RTS

graphlib@0007
horiz:
;Input:	d0.w = x1
;	d1.w = y
;	d2.w = x2
;	d3.w = color  	0 -> Video Invert
;			1 -> White
;			2 -> Black
	movem.l	d0-d4/a1,-(a7)
	cmp.w d0,d2
	bgt.s plush
	exg d0,d2
plush:
	sub.w d0,d2		;largeur
	bsr.s commun

debut:
	tst.b d3
	beq.s debutchange
	cmp.b #1,d3
	beq.s debutblanc

debutnoir:
	bset d0,(a1)
	subq.w #1,d2
	bmi.s fini
	dbra d0,debutnoir
	addq.l #1,a1
milieunoir:
	subq.w #8,d2
	blt.s fin
	st.b (a1)+
	bra.s milieunoir

debutchange:
	bchg d0,(a1)
	subq.w #1,d2
	bmi.s fini
	dbra d0,debutchange
	addq.l #1,a1
milieuchange:
	subq.w #8,d2
	blt.s fin
	not.b (a1)+
	bra.s milieuchange

debutblanc:
	bclr d0,(a1)
	subq.w #1,d2
	bmi.s fini
	dbra d0,debutblanc
	addq.l #1,a1
milieublanc:
	subq.w #8,d2
	blt.s fin
	clr.b (a1)+
	bra.s milieublanc

fin:
	moveq #7,d0
	addq.w #8,d2
	bra.s debut
fini:
	movem.l	(a7)+,d0-d4/a1
	RTS

graphlib@0000
fill:
;Input:	d0.w = x
;	d1.w = y
;	d2.w = width
;	d3.w = height
;	d4.w = color:	0 -> Video Invert
;			1 -> White
;			2 -> Black

	movem.l d0-d4,-(a7)
	add.w d0,d2		;pour obtenir x2
	exg d3,d4
fillhoriz:
	bsr.s horiz
	addq.w #1,d1
	dbra d4,fillhoriz
	movem.l (a7)+,d0-d4
	RTS

graphlib@0016
clear_dialog:
	movem.l d0-d4/a5,-(a7)
	lea dialogpos(pc),a5
	movem.w (a5),d0-d3
	moveq #1,d4
	bsr.s fill
	movem.l (a7)+,d0-d4/a5
	RTS

graphlib@0018
erase_rect:
	movem.l d0-d4/a6,-(a7)
	lea 28(a7),a6
	move.w (a6)+,d0
	move.w (a6)+,d1
	move.w (a6)+,d2
	move.w (a6)+,d3
	sub.w d0,d2		;largeur
	sub.w d1,d3		;hauteur
	moveq #1,d4		;en blanc
	bsr.s fill
	movem.l (a7)+,d0-d4/a6
	RTS

graphlib@0015
show_dialog:
	movem.l d0-d7/a0-a6,-(a7)
	move.w (a6)+,d0
	move.w (a6)+,d1
	move.w (a6)+,d2
	move.w (a6)+,d3
	sub.w d0,d2		;largeur
	sub.w d1,d3		;hauteur
	lea dialogpos(pc),a5
	movem.w d0-d3,(a5)
	moveq #1,d4		;en blanc
	bsr.s fill
	move.w d2,d4
	move.w d3,d5
	addq.w #1,d0
	addq.w #1,d1
	subq.w #2,d4
	subq.w #2,d5
	bsr commun2
	move.w #2,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
	move.w d0,d7	;sauvegarde la fonte
	move.w (a6)+,d2
	move.w (a6)+,d3
	movem.w (a5),d0-d1	;recouvre x1 et y1
	add.w d2,d0
	add.w d3,d1
	WriteStrA d0,d1,#4,(a6)
	move.w d7,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
	movem.l (a7)+,d0-d7/a0-a6
	RTS

graphlib@0019
frame_rect:
	movem.l d0-d5/a6,-(a7)
	lea 32(a7),a6
	move.w (a6)+,d0
	move.w (a6)+,d1
	move.w (a6)+,d4
	move.w (a6)+,d5
	sub.w d0,d4		;largeur
	sub.w d1,d5		;hauteur
	bsr frame
	movem.l (a7)+,d0-d5/a6
	RTS


graphlib@0009
scrtomem:
;Input:	d0.w = X of top left-hand corner in bytes(0<X<30)
;	d1.w = Y of top left-hand corner (0<Y<128)
;	d2.w = width in bytes (0<d2<30)  
;	d3.w = height (0<d3<128)         
;
;Output: d4.w = handle to the memory containg the part of the screen.

	movem.l d0-d3/d5-d7/a0-a6,-(a7)
	movem.l d0-d3,-(a7)
	mulu.w d2,d3
	move.l d3,-(a7)
	jsr tios::HeapAlloc
	addq.l #4,a7
	move.w d0,-(a7)
	jsr tios::HeapDeref
	move.w (a7)+,d4
	movem.l (a7)+,d0-d3
	bsr screen
	mulu.w #30,d1
	add.w d0,d1
	add.w d1,a1

	subq.w #1,d2	;pour les DBRA
	subq.w #1,d3
rangee:
	move.w d2,d5
	move.l a1,a2
copielargeur:
	move.b (a2)+,(a0)+
	dbra d5,copielargeur
	lea 30(a1),a1
	dbra d3,rangee

	movem.l (a7)+,d0-d3/d5-d7/a0-a6
	RTS

graphlib@000A
memtoscr:
;Input:	d0.w = X of top left-hand corner in bytes(0<X<30)
;	d1.w = Y of top left-hand corner (0<Y<128)
;	d2.w = width in bytes (0<d2<30)
;	d3.w = height (0<d3<128)
;	d4.w = handle previously created by memtoscr(containing the
;					part of the screen to restore)

	movem.l d0-d7/a0-a6,-(a7)

	move.w d4,d5
	DEREF d5,a0

	bsr screen

	mulu.w #30,d1
	add.w d0,d1
	add.w d1,a1

	subq.w #1,d2	;pour les DBRA
	subq.w #1,d3
rangee2:
	move.w d2,d5
	move.l a1,a2
copielargeur2:
	move.b (a0)+,(a2)+
	dbra d5,copielargeur2
	lea 30(a1),a1
	dbra d3,rangee2

	move.w d4,-(a7)
	jsr tios::HeapFree
	addq.l #2,a7
	movem.l (a7)+,d0-d7/a0-a6
	RTS

graphlib@0001
put_sprite:
	movem.l d6-d7/a2,-(a7)

	move.w (a0),d6
	move.w 2(a0),d7
	mulu.w d6,d7
	lea 4(a0,d7.w),a2
	bsr.s put_sprite2

	movem.l (a7)+,d6-d7/a2
	RTS

graphlib@000B
put_sprite_mask:
	movem.l d0-d7/a0-a6,-(a7)
	move.w (a0)+,d6	;hauteur en pixels
	move.w (a0)+,d7	;largeur en octets
	subq.w #1,d6	;pour les DBRA
	subq.w #1,d7

	bsr commun

	addq.b #1,d0	;pour viter un dcalage  droite

	clr.w d4
	move.b d3,d4
	lsl.w d0,d4

toutsprite:
	move.w d7,d5
	move.l a1,a3
lignesprite:
	move.w d4,d3
	bsr.s afficheoctet
	dbra d5,lignesprite
	lea 30(a1),a1
	dbra d6,toutsprite

	movem.l (a7)+,d0-d7/a0-a6
	RTS

afficheoctet:
;	d0=dcalage
;	d2=bout du sprite
;	d3=masque
;	a3=adresse de l'cran

	clr.w d2
	move.b (a0)+,d2
	lsl.w d0,d2

	move.b (a3)+,d1	;pour viter une jolie "Address Error"
	lsl.w #8,d1
	move.b (a3),d1

	or.w d2,d1		;affiche les pixels

	not.w d3
	or.w d3,d2		;seuls les 0 qui doivent tre affichs restent des 0
	and.w d2,d1		;efface...

	move.b d1,(a3)
	lsr.w #8,d1
	move.b d1,-1(a3)

	RTS

graphlib@000C
put_sprite2:
	movem.l d0-d7/a0-a6,-(a7)
	move.w (a0)+,d6	;hauteur en pixels
	move.w (a0)+,d7	;largeur en octets
	subq.w #1,d6	;pour les DBRA
	subq.w #1,d7

	bsr commun

	addq.b #1,d0	;pour viter un dcalage  droite

toutsprite2:
	move.w d7,d5
	move.l a1,a3
lignesprite2:
	clr.w d3
	move.b (a2)+,d3
	lsl.w d0,d3
	bsr.s afficheoctet
	dbra d5,lignesprite2
	lea 30(a1),a1
	dbra d6,toutsprite2

	movem.l (a7)+,d0-d7/a0-a6

	RTS

graphlib@0014
clr_scr2:
	movem.l d0-d3,-(a7)
	bsr.s clr_scr
	clr.w d0
	move.w #LCD_HEIGHT-7,d1
	move.w #160,d2
	moveq #2,d3
	bsr horiz
	movem.l (a7)+,d0-d3
	RTS

graphlib@0005
clr_scr:
	movem.l	d0/a1,-(a7)
	bsr screen
	move.l #3840/4-1,d0
zap:
	clr.l (a1)+
	dbra d0,zap
	movem.l	(a7)+,d0/a1
	RTS

graphlib@001A
getlength:
;Input:	a0 = string
;Output:	d3 = length
;		d4 = heigth

	movem.l d0-d2/a0-a2,-(a7)
	clr.w d3
	jsr tios::FontGetSys
	lea tios::font_small,a1
loopgetlength:
	tst.b (a0)
	beq.s fingetlength

	tst.b d0
	beq.s small
	cmp.b #1,d0
	beq.s medium
large:
	moveq #10,d4
	addq.w #8,d3
	bra.s finloop
medium:
	moveq #8,d4
	addq.w #6,d3
	bra.s finloop
small:
	moveq #5,d4
	clr.l d2		;pour la multiplication
	move.b (a0),d2
	mulu.w #6,d2
	add.b 0(a1,d2.w),d3
finloop:
	addq.l #1,a0
	bra.s loopgetlength
fingetlength:
	movem.l (a7)+,d0-d2/a0-a2
	RTS

graphlib@0017
line:
	movem.l d0-d7/a0,-(a7)
	cmp.w d0,d2
	bgt.s plusl		;prend le point le plus  gauche
	exg d0,d2
	exg d1,d3
plusl:
	move.w d1,d4
	lsl.w #1,d4
	move.w d4,d5
	lsl.w #4,d4
	sub.w d5,d4		;y*30->y
	move.w d0,d5
	lsr.w #3,d5		;x/8->x
	add.w d5,d4
	move.w d0,d5
	not.b d5
	and.b #7,d5		;obtient le pixel  changer
	add.w d4,a0
	bset d5,(a0)
	moveq #1,d6
	lsl.w d5,d6
	move.w d2,d5
	sub.w d0,d5		;pour obtenir la largeur
	moveq #30,d4
	move.w d3,d7
	sub.w d1,d7
	bcc.s descend
	neg.w d4
	neg.w d7
descend:
	cmp.w d0,d2
	bne.s pasfini
	cmp.w d1,d3
	beq.s finil
pasfini:
	cmp.w d5,d7		;plus large ou plus haut ?
	bcc.s plushaut
pluslarge:
	move.w d5,d2
	subq.w #1,d2
	move.w d7,d3
	sub.w d5,d3
	lsl.w #1,d3	;asl ?
	lsl.w #1,d7
	sub.w d7,d5
	neg.w d5
colonneloop:
	tst.w d5
	bmi.s pointdroite
	add.w d4,a0
	add.w d3,d5
	bra.s changecolonne
pointdroite:
	add.w d7,d5
changecolonne:
	ror.b #1,d6
	bcc.s OKoctet
	addq.l #1,a0
OKoctet:
	or.b d6,(a0)
	dbra d2,colonneloop
	bra.s finil
plushaut:
	move.w d7,d3
	subq.w #1,d3
	move.w d5,d2
	sub.w d7,d2
	lsl.w #1,d2
	lsl.w #1,d5
	sub.w d5,d7
	neg.w d7
ligneloop:
	tst.w d7
	bmi.s pointbas
	ror.b #1,d6
	bcc.s memeoctet
	addq.l #1,a0
memeoctet:
	add.w d2,d7
	bra.s changeligne
pointbas:
	add.w d5,d7
changeligne:
	add.w d4,a0
	or.b d6,(a0)
	dbra d3,ligneloop
finil:
	movem.l (a7)+,d0-d7/a0
	RTS

graphlib@000F
gray4:
	movem.l d1-d7/a0-a6,-(a7)

	bsr.s	gray2		;pour bomber89...
	move.l  #$F00*1+8,-(a7)
	jsr tios::HeapAllocHigh
	addq.l   #4,a7
	move.w	d0,handle
	beq.s	graylib_fail
	move.l #$00000400,table
	bsr.s	DEREF_Mult8
	move.l  a1,plane1		;adresse relle

	move.w #3840/4-1,d0
erase4:
	clr.l (a1)+
	dbra d0,erase4
	move.l	$64,oldint1
	move.l	#int_1_g4,$40064
	movem.l (a7)+,d1-d7/a0-a6
	st.b	d0
	RTS

graphlib@000E
gray2:
       movem.l d1-d7/a0-a6,-(a7)
	lea		oldint1(pc),a0
	tst.l		(a0)
	beq.s		graylib_fail

	move.l	(a0),$40064
	clr.l		(a0)
	move.w	#LCD_MEM/8,$600010
	move.l	#$4C00,plane0
        move.w  handle(pc),-(a7)
        jsr tios::HeapFree
        addq.l   #2,a7
graylib_fail:
        movem.l (a7)+,d1-d7/a0-a6
	clr.l	d0
	RTS

DEREF_Mult8
	lsl.w #2,d0
	move.l tios::Heap,a0
	move.l 0(a0,d0.w),d0
	addq.l	#7,d0
	lsr.l	#3,d0
	lsl.l	#3,d0
	move.l d0,a1
	RTS

graphlib@0010
gray7:
	movem.l	d1-d7/a0-a6,-(a7)
	move.l	#$F00*2+8,-(a7)
	jsr	tios::HeapAllocHigh
	addq.l	#4,a7
	move.w	d0,handle
	beq.s	graylib_fail
	move.l #$00080004,table
	lea plane1(pc),a5
	bsr.s		DEREF_Mult8
	move.l	a1,(a5)+	;plane1
	lea		$F00(a1),a2
	move.l	a2,(a5)	;plane2

	move.w #3840/4-1,d0
erase7:
	clr.l (a1)+
	clr.l (a2)+
	dbra	d0,erase7
	move.l	$64,oldint1
	move.l	#int_1_g7,$40064
	movem.l	(a7)+,d1-d7/a0-a6
	st.b	d0
	RTS

screen:
	tst.w choosescreen
	bne.s nochange
	lea $4C00,a1
nochange:
	RTS

;*****************************************************

int_1_g4:
	move.w	#$2700,sr
	movem.l	d0/a0,-(a7)
	lea		vbl_phase(pc),a0
	addq.b	#1,(a0)
	and.b		#3,(a0)+
	bne.s	int_1_skip_g4
	subq.b	#1,(a0)	;phase
	bne.s no_wrap_g4
	move.b	#3,(a0)
no_wrap_g4:
	bsr.s plane
int_1_skip_g4:
	movem.l	(a7)+,d0/a0
	move.l	oldint1(pc),-(a7)
	rts

plane:
	clr.w		d0
	move.b	(a0),d0	;phase
	move.b	0(a0,d0.w),d0	;numro de l'cran
	lea		plane0(pc),a0
	move.l	0(a0,d0.w),d0
	lsr.l		#3,d0
	move.w	d0,$600010
	RTS

;*****************************************************

int_1_g7:
	move.w	#$2700,sr
	movem.l	d0/a0,-(a7)
	lea		vbl_phase(pc),a0
	addq.b	#1,(a0)
	and.b		#7,(a0)+
	beq.s	int_1_skip_g7
	subq.b	#1,(a0)	;phase
	bne.s no_wrap_g7
	move.b	#6,(a0)
no_wrap_g7:
	bsr.s plane
int_1_skip_g7:
	movem.l	(a7)+,d0/a0
	move.l	oldint1(pc),-(a7)
	rts

;*****************************************************
; miscellaneous program data
;*****************************************************

graphlib@0011
plane0		dc.l $4C00
graphlib@0012
plane1		dc.l 0
graphlib@0013
plane2		dc.l 0
graphlib@000D
choosescreen	dc.w 0
handle		dc.w 0
dialogpos		ds.w 4
oldint1		dc.l 0
vbl_phase	dc.b	0
phase		dc.b	2
table		dc.b	0,8,0,4,0,8

	end